extern	printf

;core.asm
extern	min
extern	minu
extern	max
extern	maxu
extern	islower
extern	isupper
extern	tolower
extern	toupper
;console.asm
extern	print
extern	puts
;string.asm
extern	strlen
extern	strcpy
extern	strcat
extern	strcmp

section	.rodata
	PRINT_nums	equ	1
	PRINT_strs	equ	1
	TEST_min	equ	1 ;includes minu
	TEST_max	equ	1 ;includes maxu
	TEST_print	equ	1
	TEST_puts	equ	1
	TEST_strlen	equ	1
	TEST_islower	equ	1
	TEST_isupper	equ	1
	TEST_strcpy	equ	1
	TEST_strcat	equ	1
	TEST_tolower	equ	1
	TEST_toupper	equ	1
	TEST_strcmp	equ	1

	num1		dq	13
	num2		dq	-25
	num3		equ	60
	msgNums		db	"> num1: %d",10,"> num2: %d",10,"> num3: %d",10,0
	msgMin		db	"min(num1, num2): %d",10,0
	msgMin2		db	"minu(num1, num3): %d",10,0
	msgMin3		db	"min(num2, num3): %d",10,0
	msgMax		db	"max(num1, num2): %d",10,0
	msgMax2		db	"maxu(num1, num3): %d",10,0
	msgMax3		db	"max(num2, num3): %d",10,0
	msgPrint	db	"print() test",0
	msgPuts		db	" and puts() test",0
	str1		db	"Hello, world!",0
	str2		db	"Hello World!",0
	str3		db	"Howdy environment!",0
	msgStrings	db	"> str1: %s",10,"> str2: %s",10,"> str3: %s",10,0
	msgStrlen	db	"strlen(str1): %d",10,0
	msgStrlen2	db	"strlen(str3): %d",10,0
	msgIslower	db	"islower(str1[0]): %d",10,0
	msgIslower2	db	"islower(str1[1]): %d",10,0
	msgIsupper	db	"isupper(str1[0]): %d",10,0
	msgIsupper2	db	"isupper(str1[1]): %d",10,0
	msgStrcpy	db	"strcpy(strBuff, str1): %s",10,0
	msgStrcat	db	"strcat(strBuff, str3): %s",10,0
	msgStrlen3	db	"strlen(strBuff): %d",10,0
	msgTolower	db	"tolower(str1[0]): %c",10,0
	msgTolower2	db	"tolower(str1[1]): %c",10,0
	msgTolower3	db	"tolower() for whole strBuff: %s",10,0
	msgToupper	db	"toupper(str1[0]): %c",10,0
	msgToupper2	db	"toupper(str1[1]): %c",10,0
	msgToupper3	db	"toupper() for whole strBuff: %s",10,0
	msgStrcmp	db	"strcmp(str1, str2): %d",10,0
	msgStrings2	db	"Comparing...",10,"> str1: %s",10,"> strBuff: %s",10,0
	msgStrcmp2	db	"strcmp(str1, strBuff): %d",10,0
section	.data
section	.bss
	strBuff	resb	32
section .text
	global main
main:
	push	rbp
	mov	rbp, rsp

%IF PRINT_nums
	; PRINT: num1, num2, num3
	xor	rax, rax
	lea	rdi, [rel msgNums]
	mov	rsi, [rel num1]
	mov	rdx, [rel num2]
	mov	rcx, num3
	call	printf
%ENDIF
%IF TEST_min
	; TEST: min()
	mov	rdi, [rel num1]
	mov	rsi, [rel num2]
	call	min
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgMin]
	call	printf
	;
	mov	rdi, [rel num1]
	mov	rsi, num3
	call	minu
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgMin2]
	call	printf
	;	
	mov	rdi, [rel num2]
	mov	rsi, num3
	call	min
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgMin3]
	call	printf
%ENDIF
%IF TEST_max
	; TEST: max()
	mov	rdi, [rel num1]
	mov	rsi, [rel num2]
	call	max
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgMax]
	call	printf
	;
	mov	rdi, [rel num1]
	mov	rsi, num3
	call	maxu
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgMax2]
	call	printf
	;	
	mov	rdi, [rel num2]
	mov	rsi, num3
	call	max
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgMax3]
	call	printf
%ENDIF
%IF TEST_print	
	; TEST: print()
	lea	rdi, [rel msgPrint]
	call	print
%ENDIF
%IF TEST_puts
	; TEST: puts()
	lea	rdi, [rel msgPuts]
	call	puts
%ENDIF
%IF PRINT_strs
	; PRINT: str1, str2, str3
	xor	rax, rax
	lea	rdi, [rel msgStrings]
	lea	rsi, [rel str1]
	lea	rdx, [rel str2]
	lea	rcx, [rel str3]
	call	printf
%ENDIF
%IF TEST_strlen
	; TEST: strlen()
	lea	rdi, [rel str1]
	call	strlen
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgStrlen]
	call	printf
	;
	lea	rdi, [rel str3]
	call	strlen
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgStrlen2]
	call	printf
%ENDIF
%IF TEST_islower
	; TEST: islower()
	lea	rdi, [rel str1]
	call	islower
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgIslower]
	call	printf
	;
	lea	rdi, [rel str1+1]
	call	islower
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgIslower2]
	call	printf
%ENDIF
%IF TEST_isupper
	; TEST: isupper()
	lea	rdi, [rel str1]
	call	isupper
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgIsupper]
	call	printf
	;
	lea	rdi, [rel str1+1]
	call	isupper
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgIsupper2]
	call	printf
%ENDIF
%IF TEST_strcpy
	; TEST: strcpy()
	lea	rdi, [rel strBuff]
	lea	rsi, [rel str1]
	call	strcpy
	xor	rax, rax
	lea	rdi, [rel msgStrcpy]
	lea	rsi, [rel strBuff]
	call	printf
%ENDIF
%IF TEST_strcat
	; TEST: strcat()
	lea	rdi, [rel strBuff]
	lea	rsi, [rel str3]
	call	strcat
	xor	rax, rax
	lea	rdi, [rel msgStrcat]
	lea	rsi, [rel strBuff]
	call	printf
%ENDIF
%IF TEST_strcat
	%IF TEST_strlen
	; TEST: strlen() for strBuff
	lea	rdi, [rel strBuff]
	call	strlen
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgStrlen3]
	call	printf
	%ENDIF
%ENDIF
%IF TEST_tolower
	; TEST: tolower(str1[0])
	lea	rdi, [rel str1]
	call	tolower
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgTolower]
	call	printf
	; ...str1[1]
	lea	rdi, [rel str1+1]
	call	tolower
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgTolower2]
	call	printf
%ENDIF
%IF TEST_toupper
	; TEST: toupper(str1[0])
	lea	rdi, [rel str1]
	call	toupper
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgToupper]
	call	printf
	; ...str1[1]
	lea	rdi, [rel str1+1]
	call	toupper
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgToupper2]
	call	printf
%ENDIF
%IF TEST_tolower
	; TEST: tolower: entire strBuff
	lea	rdi, [rel strBuff]
	call	strlen
	mov	rcx, rax
	.tolowerLoop:
		movzx	r10, byte [rdi]
		mov	byte [rdi], r10b
		push	rcx
		sub	rsp, 8
		call	tolower
		add	rsp, 8
		pop	rcx
		mov	byte [rdi], al
		inc	rdi
		inc	r10
		loop	.tolowerLoop
	xor	rax, rax
	lea	rdi, [rel msgTolower3]
	lea	rsi, [rel strBuff]
	call	printf
%ENDIF
%IF TEST_toupper
	; TEST: toupper: entire strBuff
	lea	rdi, [rel strBuff]
	call	strlen
	mov	rcx, rax
	.toupperLoop:
		movzx	r10, byte [rdi]
		mov	byte [rdi], r10b
		push	rcx
		sub	rsp, 8
		call	toupper
		add	rsp, 8
		pop	rcx
		mov	byte [rdi], al
		inc	rdi
		inc	r10
		loop	.toupperLoop
	xor	rax, rax
	lea	rdi, [rel msgToupper3]
	lea	rsi, [rel strBuff]
	call	printf
%ENDIF
%IF TEST_strcmp
	; TEST: strcmp(str1, str2)
	lea	rdi, [rel str1]
	lea	rsi, [rel str2]
	call	strcmp
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgStrcmp]
	call	printf
	;
	lea	rdi, [rel strBuff]
	lea	rsi, [rel str1]
	call	strcpy
	lea	rdi, [rel strBuff]
	lea	rsi, [rel str3]
	call	strcat
	%IF PRINT_strs
		xor	rax, rax
		lea	rdi, [rel msgStrings2]
		lea	rsi, [rel str1]
		lea	rdx, [rel strBuff]
		call	printf
	%ENDIF
	lea	rdi, [rel str1]
	lea	rsi, [rel strBuff]
	call	strcmp
	mov	rsi, rax
	xor	rax, rax
	lea	rdi, [rel msgStrcmp2]
	call	printf
%ENDIF
	leave
	ret
